diff --git a/app/test/test_cmdline_cirbuf.c b/app/test/test_cmdline_cirbuf.c
index 87f83cc..2c32145 100644
--- a/app/test/test_cmdline_cirbuf.c
+++ b/app/test/test_cmdline_cirbuf.c
@@ -45,7 +45,7 @@
 #define CIRBUF_STR_HEAD " HEAD"
 #define CIRBUF_STR_TAIL "TAIL"
 
-/* miscelaneous tests - they make bullseye happy */
+/* miscellaneous tests - they make bullseye happy */
 static int
 test_cirbuf_string_misc(void)
 {
diff --git a/app/test/test_distributor.c b/app/test/test_distributor.c
index 9e8c06d..5c22f84 100644
--- a/app/test/test_distributor.c
+++ b/app/test/test_distributor.c
@@ -96,7 +96,7 @@ handle_work(void *arg)
 /* do basic sanity testing of the distributor. This test tests the following:
  * - send 32 packets through distributor with the same tag and ensure they
  *   all go to the one worker
- * - send 32 packets throught the distributor with two different tags and
+ * - send 32 packets through the distributor with two different tags and
  *   verify that they go equally to two different workers.
  * - send 32 packets with different tags through the distributors and
  *   just verify we get all packets back.
diff --git a/app/test/test_eal_flags.c b/app/test/test_eal_flags.c
index 0a8269c..738bbe4 100644
--- a/app/test/test_eal_flags.c
+++ b/app/test/test_eal_flags.c
@@ -747,7 +747,7 @@ test_dom0_misc_flags(void)
 
 	/* check that some general flags don't prevent things from working.
 	 * All cases, apart from the first, app should run.
-	 * No futher testing of output done.
+	 * No further testing of output done.
 	 */
 	/* sanity check - failure with invalid option */
 	const char *argv0[] = {prgname, prefix, mp_flag, "-c", "1", "--invalid-opt"};
@@ -855,7 +855,7 @@ test_misc_flags(void)
 
 	/* check that some general flags don't prevent things from working.
 	 * All cases, apart from the first, app should run.
-	 * No futher testing of output done.
+	 * No further testing of output done.
 	 */
 	/* sanity check - failure with invalid option */
 	const char *argv0[] = {prgname, prefix, mp_flag, "-c", "1", "--invalid-opt"};
diff --git a/app/test/test_func_reentrancy.c b/app/test/test_func_reentrancy.c
index 45928fa..87121da 100644
--- a/app/test/test_func_reentrancy.c
+++ b/app/test/test_func_reentrancy.c
@@ -137,7 +137,7 @@ ring_create_lookup(__attribute__((unused)) void *arg)
 			return -1;
 	}
 
-	/* verify all ring created sucessful */
+	/* verify all ring created successful */
 	for (i = 0; i < MAX_ITER_TIMES; i++) {
 		snprintf(ring_name, sizeof(ring_name), "fr_test_%d_%d", lcore_self, i);
 		if (rte_ring_lookup(ring_name) == NULL)
@@ -191,7 +191,7 @@ mempool_create_lookup(__attribute__((unused)) void *arg)
 			return -1;
 	}
 
-	/* verify all ring created sucessful */
+	/* verify all ring created successful */
 	for (i = 0; i < MAX_ITER_TIMES; i++) {
 		snprintf(mempool_name, sizeof(mempool_name), "fr_test_%d_%d", lcore_self, i);
 		if (rte_mempool_lookup(mempool_name) == NULL)
diff --git a/app/test/test_hash.c b/app/test/test_hash.c
index 178ec3f..ce7c533 100644
--- a/app/test/test_hash.c
+++ b/app/test/test_hash.c
@@ -953,7 +953,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(NULL);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully without any parameter\n");
+		printf("Impossible creating hash successfully without any parameter\n");
 		return -1;
 	}
 
@@ -963,7 +963,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(&params);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully with entries in parameter exceeded\n");
+		printf("Impossible creating hash successfully with entries in parameter exceeded\n");
 		return -1;
 	}
 
@@ -973,7 +973,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(&params);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully with bucket_entries in parameter exceeded\n");
+		printf("Impossible creating hash successfully with bucket_entries in parameter exceeded\n");
 		return -1;
 	}
 
@@ -983,7 +983,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(&params);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully if entries less than bucket_entries in parameter\n");
+		printf("Impossible creating hash successfully if entries less than bucket_entries in parameter\n");
 		return -1;
 	}
 
@@ -993,7 +993,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(&params);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully if entries in parameter is not power of 2\n");
+		printf("Impossible creating hash successfully if entries in parameter is not power of 2\n");
 		return -1;
 	}
 
@@ -1003,7 +1003,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(&params);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully if bucket_entries in parameter is not power of 2\n");
+		printf("Impossible creating hash successfully if bucket_entries in parameter is not power of 2\n");
 		return -1;
 	}
 
@@ -1013,7 +1013,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(&params);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully if key_len in parameter is zero\n");
+		printf("Impossible creating hash successfully if key_len in parameter is zero\n");
 		return -1;
 	}
 
@@ -1023,7 +1023,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(&params);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully if key_len is greater than the maximum\n");
+		printf("Impossible creating hash successfully if key_len is greater than the maximum\n");
 		return -1;
 	}
 
@@ -1033,7 +1033,7 @@ static int test_hash_creation_with_bad_parameters(void)
 	handle = rte_hash_create(&params);
 	if (handle != NULL) {
 		rte_hash_free(handle);
-		printf("Impossible creating hash sucessfully with invalid socket\n");
+		printf("Impossible creating hash successfully with invalid socket\n");
 		return -1;
 	}
 
diff --git a/app/test/test_interrupts.c b/app/test/test_interrupts.c
index 6e3dec3..e7f4599 100644
--- a/app/test/test_interrupts.c
+++ b/app/test/test_interrupts.c
@@ -408,7 +408,7 @@ test_interrupt(void)
 
 	printf("Check unknown valid interrupt full path\n");
 	if (test_interrupt_full_path_check(TEST_INTERRUPT_HANDLE_VALID) < 0) {
-		printf("failure occured during checking unknown valid "
+		printf("failure occurred during checking unknown valid "
 						"interrupt full path\n");
 		goto out;
 	}
@@ -416,7 +416,7 @@ test_interrupt(void)
 	printf("Check valid UIO interrupt full path\n");
 	if (test_interrupt_full_path_check(TEST_INTERRUPT_HANDLE_VALID_UIO)
 									< 0) {
-		printf("failure occured during checking valid UIO interrupt "
+		printf("failure occurred during checking valid UIO interrupt "
 								"full path\n");
 		goto out;
 	}
@@ -424,7 +424,7 @@ test_interrupt(void)
 	printf("Check valid alarm interrupt full path\n");
 	if (test_interrupt_full_path_check(TEST_INTERRUPT_HANDLE_VALID_ALARM)
 									< 0) {
-		printf("failure occured during checking valid alarm "
+		printf("failure occurred during checking valid alarm "
 						"interrupt full path\n");
 		goto out;
 	}
diff --git a/app/test/test_ivshmem.c b/app/test/test_ivshmem.c
index 4e61488..bc5417c 100644
--- a/app/test/test_ivshmem.c
+++ b/app/test/test_ivshmem.c
@@ -243,7 +243,7 @@ test_ivshmem_api_test(void)
 
 	ASSERT(rte_ivshmem_metadata_cmdline_generate(buf, sizeof(buf),
 			NONEXISTENT_METADATA) < 0,
-			"Writen command line for nonexistent metadata");
+			"Written command line for nonexistent metadata");
 	ASSERT(strnlen(buf, sizeof(buf)) == 0, "Buffer is not empty");
 
 	/* add stuff to config */
diff --git a/app/test/test_link_bonding.c b/app/test/test_link_bonding.c
index 4523de6..3e7633d 100644
--- a/app/test/test_link_bonding.c
+++ b/app/test/test_link_bonding.c
@@ -4366,7 +4366,7 @@ test_tlb_verify_mac_assignment(void)
 	/* Set explicit MAC address */
 	TEST_ASSERT_SUCCESS(rte_eth_bond_mac_address_set(
 			test_params->bonded_port_id, (struct ether_addr *)bonded_mac),
-			"failed to set MAC addres");
+			"failed to set MAC address");
 
 	rte_eth_macaddr_get(test_params->bonded_port_id, &read_mac_addr);
 	TEST_ASSERT_SUCCESS(memcmp(&bonded_mac, &read_mac_addr,
diff --git a/app/test/test_malloc.c b/app/test/test_malloc.c
index 8c53132..ebab582 100644
--- a/app/test/test_malloc.c
+++ b/app/test/test_malloc.c
@@ -813,7 +813,7 @@ err_return:
 	return -1;
 }
 
-/* Check if memory is avilable on a specific socket */
+/* Check if memory is available on a specific socket */
 static int
 is_mem_on_socket(int32_t socket)
 {
diff --git a/app/test/test_mbuf.c b/app/test/test_mbuf.c
index e86ba22..957119a 100644
--- a/app/test/test_mbuf.c
+++ b/app/test/test_mbuf.c
@@ -506,7 +506,7 @@ test_pktmbuf_free_segment(void)
  * Stress test for rte_mbuf atomic refcnt.
  * Implies that:
  * RTE_MBUF_REFCNT and RTE_MBUF_REFCNT_ATOMIC are both defined.
- * For more efficency, recomended to run with RTE_LIBRTE_MBUF_DEBUG defined.
+ * For more efficiency, recommended to run with RTE_LIBRTE_MBUF_DEBUG defined.
  */
 
 #if defined RTE_MBUF_REFCNT  && defined RTE_MBUF_REFCNT_ATOMIC
diff --git a/app/test/test_spinlock.c b/app/test/test_spinlock.c
index c95b0c0..29cc7aa 100644
--- a/app/test/test_spinlock.c
+++ b/app/test/test_spinlock.c
@@ -203,7 +203,7 @@ test_spinlock_perf(void)
 
 /*
  * Use rte_spinlock_trylock() to trylock a spinlock object,
- * If it could not lock the object sucessfully, it would
+ * If it could not lock the object successfully, it would
  * return immediately and the variable of "count" would be
  * increased by one per times. the value of "count" could be
  * checked as the result later.